<script>
import { minValue, required, requiredIf } from 'vuelidate/lib/validators';
import { settingService } from '../../../services'
import { error_message, success_message } from '../../../Helper/helper';
import config from '../../../config';

export default {
  data() {
    return {
        config:config,
        setting: {
            is_order_assigned_manually:'0',
            is_enable_live_tracking_app:'0',
            clent_auto_cancel_order_max_time:'',
            order_dashboard_default_time:'0',
            order_notification_sound:'public/sounds/notification.mp3',
            is_upload_order_image:'0',
            order_image_upload_limit:'',    
            image_upload_text:''
        },
        default_time_options:config.default_time_options,
        default_notification_sounds:config.default_notification_sounds,
        playing: false,
        sound: null
    };
  },
  mounted(){
    this.getSetting();
  },
  validations:{
    setting:{
        clent_auto_cancel_order_max_time:{
            required,
            minValue:minValue(0)
        },
        order_image_upload_limit:{
            required:requiredIf(function(){
                return this.setting.is_upload_order_image == '1'
            }),
            minValue:minValue(0)
        },
        image_upload_text:{
            required:requiredIf(function(){
                return this.setting.is_upload_order_image == '1'
            })
        }
    }

  },
  methods: {
    getSetting(){
        settingService.getSetting().then((response) => {
            if (response.data.code === 200) {
                this.setting.is_order_assigned_manually = response.data.result.is_order_assigned_manually??'0',
                this.setting.is_enable_live_tracking_app = response.data.result.is_enable_live_tracking_app??'0',
                this.setting.clent_auto_cancel_order_max_time = response.data.result.clent_auto_cancel_order_max_time??'',
                this.setting.order_dashboard_default_time = response.data.result.order_dashboard_default_time??'0',
                this.setting.order_notification_sound = response.data.result.order_notification_sound??'public/sounds/notification.mp3',
                this.setting.is_upload_order_image = response.data.result.is_upload_order_image??'0',
                this.setting.order_image_upload_limit = response.data.result.order_image_upload_limit??'',    
                this.setting.image_upload_text = response.data.result.image_upload_text??''

            } else {
                error_message(response.data.message);
            }
        })
    },
    fromSubmit(){
        this.$v.setting.$touch()
        if(this.$v.setting.$invalid){
            return false;
        }else{
            settingService.updateSetting({data:this.setting}).then((response) => {
                if (response.data.code === 200) {
                    success_message(response.data.message);
                    this.getSetting()
                } else {
                    error_message(response.data.message);
                }
            })
        }
    },
    playSound(){
      if(!this.playing){
        this.sound = new Audio(this.config.appurl+this.setting.order_notification_sound)
        // this.sound.crossOrigin = "use-credentials";
        this.sound.onended = () => this.playSound()
        this.sound.play()
        this.playing = true
      }else{
        this.sound.pause();
        this.sound.currentTime = 0;
        this.playing = false
      }

    }
  },

};
</script>

<template>
    <div>
        <div class="row">
            <div class="col-md-12">
                <div class="card">
                    <div class="card-body">
                        <form @submit.prevent="fromSubmit">
                            <!-- Basic Settings -->
                            <div class="row">
                                <div class="col-md-4">
                                    <h5>{{ trans.get('__JSON__.Basic Settings') }}</h5>
                                </div>
                                <div class="col-md-8">
                                    <!-- Order Assigned Manually -->
                                    <div class="row">
                                        <div class="col-12">
                                            <h6>{{ trans.get('__JSON__.Order Assigned Manually') }}</h6>
                                            <div class="swtich-data ">
                                                <label class="switch">
                                                    <input type="checkbox"  class="switch-on" true-value="1"
                                                        false-value="0" v-model="setting.is_order_assigned_manually" />
                                                    <div class="slider round">
                                                        <span class="on">{{ trans.get('__JSON__.ON') }}</span>
                                                        <span class="off">{{ trans.get('__JSON__.OFF') }}</span>
                                                    </div>
                                                </label>
                                            </div>
                                            <p>{{ trans.get('__JSON__.By Enabling this Option orders will be assign to Delivery Boys Manually.')}}</p>
                                        </div>
                                        <!-- Live Tracking on Customer App -->
                                        <div class="col-12 mt-3">
                                            <h6>{{ trans.get('__JSON__.Live Tracking on Customer App') }}</h6>
                                            <div class="swtich-data ">
                                                <label class="switch">
                                                    <input type="checkbox"  class="switch-on" true-value="1"
                                                        false-value="0" v-model="setting.is_enable_live_tracking_app" />
                                                    <div class="slider round">
                                                        <span class="on">{{ trans.get('__JSON__.ON') }}</span>
                                                        <span class="off">{{ trans.get('__JSON__.OFF') }}</span>
                                                    </div>
                                                </label>
                                            </div>
                                            <p>{{ trans.get('__JSON__.By Enabling this Option customer will able to live track orders on Google map.')}}</p>
                                        </div>
                                        <!-- Auto cancel Order For (In Minutes) -->
                                        <div class="col-12 mt-3">
                                            <h6>{{ trans.get('__JSON__.Auto cancel Order For (In Minutes)',{ client: $auth.setting.restaurant_name }) }}</h6>
                                            <div class="row">
                                                <div class="col-md-6">
                                                    <input type="number" class="form-control" 
                                                    v-model="$v.setting.clent_auto_cancel_order_max_time.$model"
                                                    :class="{'is-invalid' : $v.setting.clent_auto_cancel_order_max_time.$error}"
                                                    >
                                                    <div v-if="$v.setting.clent_auto_cancel_order_max_time.$error" class="invalid-feedback">
                                                        <span v-if="!$v.setting.clent_auto_cancel_order_max_time.required">
                                                            {{ trans.get('__JSON__.This field is required') }}
                                                        </span>
                                                        <span v-if="!$v.setting.clent_auto_cancel_order_max_time.minValue">
                                                            {{ trans.get('__JSON__.Please Enter A Minimum 0 Values') }}
                                                        </span>
                                                    </div>
                                                </div>
                                            </div>
                                            <p class="mt-1">{{ trans.get('__JSON__.Order will be Cancelled if Restaurants will not Accept or confirm order with this minutes.')}}</p>
                                        </div>
                                        <!-- Order Dashboard Default Date -->
                                        <div class="col-12 mt-3">
                                            <h6>{{ trans.get('__JSON__.Order Dashboard Default Date') }}</h6>
                                            <div class="row">
                                                <div class="col-md-6">
                                                    <b-form-select 
                                                    v-model="setting.order_dashboard_default_time"
                                                    :options="default_time_options"
                                                    ></b-form-select>
                                                    <!-- :class="{'is-invalid' : $v.setting.restaurant_payment_option.$error}" -->
                                                </div>
                                            </div>
                                            <p class="mt-1">{{ trans.get('__JSON__.Set the default date range for the Ordering Dashboard page.')}}</p>
                                        </div>
                                        <!-- Order Notification Sound -->
                                        <div class="col-12 mt-3">
                                            <h6>{{ trans.get('__JSON__.Order Notification Sound') }}</h6>
                                            <div class="row">
                                                <div class="col-md-6">
                                                    <b-form-select 
                                                    v-model="setting.order_notification_sound"
                                                    :options="default_notification_sounds"
                                                    ></b-form-select>
                                                    <!-- :class="{'is-invalid' : $v.setting.restaurant_payment_option.$error}" -->
                                                </div>
                                                <div class="col-md-6">
                                                    <b-button variant="link" @click="playSound()" class="top-26"><i class="fas" :class="{'fa-play':!playing, 'fa-stop':playing}"></i></b-button>
                                                </div>
                                            </div>
                                            <p class="mt-1">{{ trans.get('__JSON__.New order notification sound')}}</p>
                                        </div>
                                        <!-- Should upload image with order -->
                                        <div class="col-12 mt-3">
                                            <h6>{{ trans.get('__JSON__.Should upload image with order?') }}</h6>
                                            <div class="swtich-data ">
                                                <label class="switch">
                                                    <input type="checkbox"  class="switch-on" true-value="1"
                                                        false-value="0" v-model="setting.is_upload_order_image" />
                                                    <div class="slider round">
                                                        <span class="on">{{ trans.get('__JSON__.ON') }}</span>
                                                        <span class="off">{{ trans.get('__JSON__.OFF') }}</span>
                                                    </div>
                                                </label>
                                            </div>
                                        </div>
                                        <template v-if="setting.is_upload_order_image =='1'">
                                            <!-- Image Upload Limit -->
                                            <div class="col-12 mt-3">
                                                <h6>{{ trans.get('__JSON__.Image Upload Limit') }}</h6>
                                                <div class="row">
                                                    <div class="col-md-6">
                                                        <input type="number" class="form-control" 
                                                        v-model="$v.setting.order_image_upload_limit.$model"
                                                        :class="{'is-invalid' : $v.setting.order_image_upload_limit.$error}"
                                                        >
                                                        <div v-if="$v.setting.order_image_upload_limit.$error" class="invalid-feedback">
                                                            <span v-if="!$v.setting.order_image_upload_limit.required">
                                                                {{ trans.get('__JSON__.This field is required') }}
                                                            </span>
                                                            <span v-if="!$v.setting.order_image_upload_limit.minValue">
                                                                {{ trans.get('__JSON__.Please Enter A Minimum 0 Values') }}
                                                            </span>
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                            <!-- Image Upload Text -->
                                            <div class="col-12 mt-3">
                                                <h6>{{ trans.get('__JSON__.Image Upload Text') }}</h6>
                                                <div class="row">
                                                    <div class="col-md-6">
                                                        <textarea  rows="3" class="form-control" v-model="$v.setting.image_upload_text.$model"
                                                        :class="{'is-invalid' : $v.setting.image_upload_text.$error}"
                                                        ></textarea>
                                                        <div v-if="$v.setting.image_upload_text.$error" class="invalid-feedback">
                                                            <span v-if="!$v.setting.image_upload_text.required">
                                                                {{ trans.get('__JSON__.This field is required') }}
                                                            </span>
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                        </template>

                                    </div>
                                </div>
                            </div>
                            <hr>
                            <button type="submit" class="form-controle btn btn-primary">
                                {{ trans.get('__JSON__.Update') }}
                            </button>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>